Index: src/Actions/unittests/Makefile.am
===================================================================
--- src/Actions/unittests/Makefile.am	(revision de20319c1dbee9fe5f9cd648d81c2c18dc6ab197)
+++ src/Actions/unittests/Makefile.am	(revision 4d4777c677260b02060c85e4d7bfae363b1c4352)
@@ -33,5 +33,6 @@
 	../Actions/unittests/ActionRegistryUnitTest.hpp \
 	../Parameters/unittests/stubs/BoxLengthValidatorStub.cpp \
-	../Parameters/unittests/stubs/BoxVectorValidatorStub.cpp
+	../Parameters/unittests/stubs/BoxVectorValidatorStub.cpp \
+	../Parameters/unittests/stubs/TimeStepPresentValidatorStub.cpp
 ActionRegistryUnitTest_LDADD = ${ACTIONLIBS}
 
@@ -41,5 +42,6 @@
 	../Actions/unittests/stubs/DummyUI.hpp \
 	../Parameters/unittests/stubs/BoxLengthValidatorStub.cpp \
-	../Parameters/unittests/stubs/BoxVectorValidatorStub.cpp
+	../Parameters/unittests/stubs/BoxVectorValidatorStub.cpp \
+	../Parameters/unittests/stubs/TimeStepPresentValidatorStub.cpp
 ActionSequenceUnitTest_LDADD = \
 	${ACTIONLIBS} \
Index: src/Parameters/Makefile.am
===================================================================
--- src/Parameters/Makefile.am	(revision de20319c1dbee9fe5f9cd648d81c2c18dc6ab197)
+++ src/Parameters/Makefile.am	(revision 4d4777c677260b02060c85e4d7bfae363b1c4352)
@@ -9,4 +9,5 @@
 	Parameters/Validators/Specific/RealSpaceMatrixInvertibleValidator.cpp \
 	Parameters/Validators/Specific/RealSpaceMatrixSymmetricValidator.cpp \
+	Parameters/Validators/Specific/TimeStepPresentValidator.cpp \
 	Parameters/Validators/Specific/VectorPositiveComponentsValidator.cpp \
 	Parameters/Validators/Specific/VectorZeroOneComponentsValidator.cpp
Index: src/Parameters/Validators/Specific/TimeStepPresentValidator.cpp
===================================================================
--- src/Parameters/Validators/Specific/TimeStepPresentValidator.cpp	(revision 4d4777c677260b02060c85e4d7bfae363b1c4352)
+++ src/Parameters/Validators/Specific/TimeStepPresentValidator.cpp	(revision 4d4777c677260b02060c85e4d7bfae363b1c4352)
@@ -0,0 +1,60 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * TimeStepPresentValidator.cpp
+ *
+ *  Created on: May 10, 2012
+ *      Author: ankele
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "TimeStepPresentValidator.hpp"
+
+#include "WorldTime.hpp"
+#include "World.hpp"
+
+bool TimeStepPresentValidator::isValid(const unsigned int & _value) const
+{
+  size_t maxTime = 0;
+  std::vector<atom*> AllAtoms = World::getInstance().getAllAtoms();
+  for(std::vector<atom*>::iterator AtomRunner = AllAtoms.begin(); AtomRunner != AllAtoms.end(); ++AtomRunner) {
+    int size = (dynamic_cast<AtomInfo *>(*AtomRunner))->getTrajectorySize();
+    if (size > maxTime)
+      maxTime = size;
+  }
+
+  return (_value < maxTime);
+}
+
+bool TimeStepPresentValidator::operator==(const Validator<unsigned int> &_instance) const
+{
+  const TimeStepPresentValidator *inst =
+      dynamic_cast<const TimeStepPresentValidator *>(&_instance);
+  if (inst)
+    return true;
+  else
+    return false;
+}
+
+Validator< unsigned int >* TimeStepPresentValidator::clone() const
+{
+  Validator< unsigned int > *inst =
+      new TimeStepPresentValidator();
+  return inst;
+}
+
+
+
+
Index: src/Parameters/Validators/Specific/TimeStepPresentValidator.hpp
===================================================================
--- src/Parameters/Validators/Specific/TimeStepPresentValidator.hpp	(revision de20319c1dbee9fe5f9cd648d81c2c18dc6ab197)
+++ src/Parameters/Validators/Specific/TimeStepPresentValidator.hpp	(revision 4d4777c677260b02060c85e4d7bfae363b1c4352)
@@ -15,11 +15,15 @@
 #endif
 
-#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Validator.hpp"
 
 /** This validator checks whether the given time step is present in the World.
  *
  */
-class TimeStepPresentValidator : public DummyValidator<unsigned int>
-{};
+class TimeStepPresentValidator : public Validator<unsigned int>
+{
+  bool isValid(const unsigned int & _value) const;
+  bool operator==(const Validator<unsigned int> &_instance) const;
+  Validator< unsigned int >* clone() const;
+};
 
 
Index: src/Parameters/unittests/stubs/TimeStepPresentValidatorStub.cpp
===================================================================
--- src/Parameters/unittests/stubs/TimeStepPresentValidatorStub.cpp	(revision 4d4777c677260b02060c85e4d7bfae363b1c4352)
+++ src/Parameters/unittests/stubs/TimeStepPresentValidatorStub.cpp	(revision 4d4777c677260b02060c85e4d7bfae363b1c4352)
@@ -0,0 +1,52 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * TimeStepPresentValidatorStub.cpp
+ *
+ *  Created on: Jun 6, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Parameters/Validators/Specific/TimeStepPresentValidator.hpp"
+
+#include "WorldTime.hpp"
+#include "World.hpp"
+
+bool TimeStepPresentValidator::isValid(const unsigned int & _value) const
+{
+  return true;
+}
+
+bool TimeStepPresentValidator::operator==(const Validator<unsigned int> &_instance) const
+{
+  const TimeStepPresentValidator *inst =
+      dynamic_cast<const TimeStepPresentValidator *>(&_instance);
+  if (inst)
+    return true;
+  else
+    return false;
+}
+
+Validator< unsigned int >* TimeStepPresentValidator::clone() const
+{
+  Validator< unsigned int > *inst =
+      new TimeStepPresentValidator();
+  return inst;
+}
+
+
+
+
